using System;
using System.Linq;
using C1WorkflowDemo.DataTypes;
using Composite.Actions;
using Composite.Data;
using Composite.Workflow;


namespace C1WorkflowDemo.Workflows
{
    [AllowPersistingWorkflow(WorkflowPersistingType.Idle)]
    public sealed partial class DeleteProductWorkflow : Composite.Workflow.Activities.FormsWorkflow
    {
        public DeleteProductWorkflow()
        {
            InitializeComponent();
        }



        private void finalizeCodeActivity_ExecuteCode(object sender, EventArgs e)
        {
            DataEntityToken dataEntityToken = (DataEntityToken)this.EntityToken;

            IProduct product = (IProduct)dataEntityToken.Data;

            IProductCategory productCategory =
                        (from pc in DataFacade.GetData<IProductCategory>()
                         where pc.Id == product.ProductCategoryId
                         select pc).Single();

            DataFacade.Delete<IProduct>(product);

            SpecificTreeRefresher specificTreeRefresher = this.CreateSpecificTreeRefresher();
            specificTreeRefresher.PostRefreshMesseges(productCategory.GetDataEntityToken());
        }
    }
}
